
_main:

;PIC16F887_I2CMaster_Protocol.c,37 :: 		void main()
;PIC16F887_I2CMaster_Protocol.c,39 :: 		ANSEL  = 0;                        // Configure AN pins as digital I/O
	CLRF       ANSEL+0
;PIC16F887_I2CMaster_Protocol.c,40 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;PIC16F887_I2CMaster_Protocol.c,41 :: 		C1ON_bit = 0;                      // Disable comparators
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;PIC16F887_I2CMaster_Protocol.c,42 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;PIC16F887_I2CMaster_Protocol.c,43 :: 		TRISB = 0;                 // Configure PORTB as output
	CLRF       TRISB+0
;PIC16F887_I2CMaster_Protocol.c,44 :: 		PORTB = 0;
	CLRF       PORTB+0
;PIC16F887_I2CMaster_Protocol.c,45 :: 		TRISA=0;
	CLRF       TRISA+0
;PIC16F887_I2CMaster_Protocol.c,46 :: 		PORTA = 0;
	CLRF       PORTA+0
;PIC16F887_I2CMaster_Protocol.c,48 :: 		I2C1_Init(100000);         // initialize I2C communication
	MOVLW      20
	MOVWF      SSPADD+0
	CALL       _I2C1_Init+0
;PIC16F887_I2CMaster_Protocol.c,49 :: 		Lcd_Init();                        // Initialize LCD
	CALL       _Lcd_Init+0
;PIC16F887_I2CMaster_Protocol.c,50 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PIC16F887_I2CMaster_Protocol.c,52 :: 		while(1)
L_main0:
;PIC16F887_I2CMaster_Protocol.c,66 :: 		for (count = 0; count <= 127; count++)
	CLRF       _count+0
L_main2:
	MOVF       _count+0, 0
	SUBLW      127
	BTFSS      STATUS+0, 0
	GOTO       L_main3
;PIC16F887_I2CMaster_Protocol.c,68 :: 		PORTA = 0b00000011;
	MOVLW      3
	MOVWF      PORTA+0
;PIC16F887_I2CMaster_Protocol.c,69 :: 		result = I2C_MasterWriteEx(0b00111111,0,count);
	MOVLW      63
	MOVWF      FARG_I2C_MasterWriteEx_chipAddress+0
	CLRF       FARG_I2C_MasterWriteEx_slaveRegister+0
	MOVF       _count+0, 0
	MOVWF      FARG_I2C_MasterWriteEx_input+0
	CALL       _I2C_MasterWriteEx+0
	MOVF       R0+0, 0
	MOVWF      _result+0
	MOVF       R0+1, 0
	MOVWF      _result+1
;PIC16F887_I2CMaster_Protocol.c,70 :: 		result = I2C_MasterWriteEx(0b00111111,1,count);
	MOVLW      63
	MOVWF      FARG_I2C_MasterWriteEx_chipAddress+0
	MOVLW      1
	MOVWF      FARG_I2C_MasterWriteEx_slaveRegister+0
	MOVF       _count+0, 0
	MOVWF      FARG_I2C_MasterWriteEx_input+0
	CALL       _I2C_MasterWriteEx+0
	MOVF       R0+0, 0
	MOVWF      _result+0
	MOVF       R0+1, 0
	MOVWF      _result+1
;PIC16F887_I2CMaster_Protocol.c,71 :: 		ByteToStr(count,txt);
	MOVF       _count+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _txt+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;PIC16F887_I2CMaster_Protocol.c,72 :: 		Lcd_Out(1,1,txt);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,73 :: 		Lcd_Out(1,6,"+");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      6
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_PIC16F887_I2CMaster_Protocol+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,74 :: 		Lcd_Out(1,7,txt);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,75 :: 		result = I2C_MasterReadEx(0b00111111,2);
	MOVLW      63
	MOVWF      FARG_I2C_MasterReadEx_chipAddress+0
	MOVLW      2
	MOVWF      FARG_I2C_MasterReadEx_slaveRegister+0
	CALL       _I2C_MasterReadEx+0
	MOVF       R0+0, 0
	MOVWF      _result+0
	MOVF       R0+1, 0
	MOVWF      _result+1
;PIC16F887_I2CMaster_Protocol.c,76 :: 		ByteToStr(result,txt);
	MOVF       R0+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _txt+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;PIC16F887_I2CMaster_Protocol.c,77 :: 		Lcd_Out(2,4,txt);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,78 :: 		if (result != count + count)
	MOVF       _count+0, 0
	ADDWF      _count+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	BTFSC      STATUS+0, 0
	INCF       R1+1, 1
	MOVF       _result+1, 0
	XORWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main12
	MOVF       R1+0, 0
	XORWF      _result+0, 0
L__main12:
	BTFSC      STATUS+0, 2
	GOTO       L_main5
;PIC16F887_I2CMaster_Protocol.c,80 :: 		ByteToStr(result,txt);
	MOVF       _result+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _txt+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;PIC16F887_I2CMaster_Protocol.c,81 :: 		if (result<0)
	MOVLW      128
	XORWF      _result+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main13
	MOVLW      0
	SUBWF      _result+0, 0
L__main13:
	BTFSC      STATUS+0, 0
	GOTO       L_main6
;PIC16F887_I2CMaster_Protocol.c,83 :: 		Lcd_Out(2,7,"TIMEOUT!");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_PIC16F887_I2CMaster_Protocol+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,84 :: 		}
	GOTO       L_main7
L_main6:
;PIC16F887_I2CMaster_Protocol.c,87 :: 		Lcd_Out(2,7,"FAILED!!!");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr3_PIC16F887_I2CMaster_Protocol+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,88 :: 		}
L_main7:
;PIC16F887_I2CMaster_Protocol.c,89 :: 		PORTA = PORTA ^ 0b00000001;
	MOVLW      1
	XORWF      PORTA+0, 1
;PIC16F887_I2CMaster_Protocol.c,90 :: 		Delay_ms(5000);
	MOVLW      51
	MOVWF      R11+0
	MOVLW      187
	MOVWF      R12+0
	MOVLW      223
	MOVWF      R13+0
L_main8:
	DECFSZ     R13+0, 1
	GOTO       L_main8
	DECFSZ     R12+0, 1
	GOTO       L_main8
	DECFSZ     R11+0, 1
	GOTO       L_main8
	NOP
	NOP
;PIC16F887_I2CMaster_Protocol.c,91 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PIC16F887_I2CMaster_Protocol.c,92 :: 		}
L_main5:
;PIC16F887_I2CMaster_Protocol.c,93 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main9:
	DECFSZ     R13+0, 1
	GOTO       L_main9
	DECFSZ     R12+0, 1
	GOTO       L_main9
	DECFSZ     R11+0, 1
	GOTO       L_main9
	NOP
	NOP
;PIC16F887_I2CMaster_Protocol.c,66 :: 		for (count = 0; count <= 127; count++)
	INCF       _count+0, 1
;PIC16F887_I2CMaster_Protocol.c,94 :: 		}
	GOTO       L_main2
L_main3:
;PIC16F887_I2CMaster_Protocol.c,95 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PIC16F887_I2CMaster_Protocol.c,96 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PIC16F887_I2CMaster_Protocol.c,97 :: 		Lcd_Out(1,1,"SUCCESS!!!");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr4_PIC16F887_I2CMaster_Protocol+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PIC16F887_I2CMaster_Protocol.c,98 :: 		Delay_ms(50000);
	MOVLW      2
	MOVWF      R10+0
	MOVLW      252
	MOVWF      R11+0
	MOVLW      77
	MOVWF      R12+0
	MOVLW      203
	MOVWF      R13+0
L_main10:
	DECFSZ     R13+0, 1
	GOTO       L_main10
	DECFSZ     R12+0, 1
	GOTO       L_main10
	DECFSZ     R11+0, 1
	GOTO       L_main10
	DECFSZ     R10+0, 1
	GOTO       L_main10
	NOP
	NOP
;PIC16F887_I2CMaster_Protocol.c,99 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PIC16F887_I2CMaster_Protocol.c,100 :: 		}
	GOTO       L_main0
;PIC16F887_I2CMaster_Protocol.c,101 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
