#line 1 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F887_I2CMaster_Protocol.c"
#line 1 "f:/documente/redresor new/pictests/pic16f887_i2cmaster_protocol/pic16f_i2c_masterfunctions.h"
#line 24 "f:/documente/redresor new/pictests/pic16f887_i2cmaster_protocol/pic16f_i2c_masterfunctions.h"
int I2C_WriteEx(unsigned char dat, unsigned long timeout_us);
int I2C_ReadEx(char acknowledge, unsigned long timeout_us);
int I2C_MasterWriteEx(unsigned char chipAddress, unsigned char slaveRegister, unsigned char input);
int I2C_MasterReadEx(unsigned char chipAddress, unsigned char slaveRegister);
#line 9 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F887_I2CMaster_Protocol.c"
char txt[4];
int result = 0;
unsigned char count = 0;


sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
#line 37 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F887_I2CMaster_Protocol.c"
void main()
{
 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 TRISB = 0;
 PORTB = 0;
 TRISA=0;
 PORTA = 0;

 I2C1_Init(100000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);

 while(1)
 {
#line 66 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F887_I2CMaster_Protocol.c"
 for (count = 0; count <= 127; count++)
 {
 PORTA = 0b00000011;
 result = I2C_MasterWriteEx(0b00111111,0,count);
 result = I2C_MasterWriteEx(0b00111111,1,count);
 ByteToStr(count,txt);
 Lcd_Out(1,1,txt);
 Lcd_Out(1,6,"+");
 Lcd_Out(1,7,txt);
 result = I2C_MasterReadEx(0b00111111,2);
 ByteToStr(result,txt);
 Lcd_Out(2,4,txt);
 if (result != count + count)
 {
 ByteToStr(result,txt);
 if (result<0)
 {
 Lcd_Out(2,7,"TIMEOUT!");
 }
 else
 {
 Lcd_Out(2,7,"FAILED!!!");
 }
 PORTA = PORTA ^ 0b00000001;
 Delay_ms(5000);
 Lcd_Cmd(_LCD_CLEAR);
 }
 Delay_ms(1000);
 }
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"SUCCESS!!!");
 Delay_ms(50000);
 Lcd_Cmd(_LCD_CLEAR);
 }
}
