
_I2C_WriteEx:

;PIC16F_I2C_MasterFunctions.c,47 :: 		int I2C_WriteEx(unsigned char dat, unsigned long timeout_us)
;PIC16F_I2C_MasterFunctions.c,49 :: 		int result = 0; // Set result to OK
	CLRF       I2C_WriteEx_result_L0+0
	CLRF       I2C_WriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,50 :: 		Delay_us(100);
	MOVLW      66
	MOVWF      R13+0
L_I2C_WriteEx0:
	DECFSZ     R13+0, 1
	GOTO       L_I2C_WriteEx0
	NOP
;PIC16F_I2C_MasterFunctions.c,51 :: 		PIR1 = PIR1&0b11110111;  //Reset SSPIF bit
	MOVLW      247
	ANDWF      PIR1+0, 1
;PIC16F_I2C_MasterFunctions.c,52 :: 		SSPBUF = dat;  //Write data to output buffer
	MOVF       FARG_I2C_WriteEx_dat+0, 0
	MOVWF      SSPBUF+0
;PIC16F_I2C_MasterFunctions.c,60 :: 		}
L_I2C_WriteEx2:
;PIC16F_I2C_MasterFunctions.c,61 :: 		if (timeout_us==0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_I2C_WriteEx_timeout_us+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx47
	MOVF       R0+0, 0
	XORWF      FARG_I2C_WriteEx_timeout_us+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx47
	MOVF       R0+0, 0
	XORWF      FARG_I2C_WriteEx_timeout_us+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx47
	MOVF       FARG_I2C_WriteEx_timeout_us+0, 0
	XORLW      0
L__I2C_WriteEx47:
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_WriteEx4
;PIC16F_I2C_MasterFunctions.c,63 :: 		PORTA=PORTA|0b00000001;
	BSF        PORTA+0, 0
;PIC16F_I2C_MasterFunctions.c,64 :: 		SSPCON2=SSPCON2|0b00000100; //PEN bit = 1;
	BSF        SSPCON2+0, 2
;PIC16F_I2C_MasterFunctions.c,65 :: 		result = -1; // Set result to -1 (TIMEOUT)
	MOVLW      255
	MOVWF      I2C_WriteEx_result_L0+0
	MOVLW      255
	MOVWF      I2C_WriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,66 :: 		goto _exitPoint;
	GOTO       ___I2C_WriteEx__exitPoint
;PIC16F_I2C_MasterFunctions.c,67 :: 		}
L_I2C_WriteEx4:
;PIC16F_I2C_MasterFunctions.c,75 :: 		}
L_I2C_WriteEx6:
;PIC16F_I2C_MasterFunctions.c,76 :: 		if (timeout_us==0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_I2C_WriteEx_timeout_us+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx48
	MOVF       R0+0, 0
	XORWF      FARG_I2C_WriteEx_timeout_us+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx48
	MOVF       R0+0, 0
	XORWF      FARG_I2C_WriteEx_timeout_us+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_WriteEx48
	MOVF       FARG_I2C_WriteEx_timeout_us+0, 0
	XORLW      0
L__I2C_WriteEx48:
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_WriteEx8
;PIC16F_I2C_MasterFunctions.c,78 :: 		PORTA=PORTA|0b00000010;
	BSF        PORTA+0, 1
;PIC16F_I2C_MasterFunctions.c,79 :: 		SSPCON2=SSPCON2|0b00000100; //PEN bit = 1;
	BSF        SSPCON2+0, 2
;PIC16F_I2C_MasterFunctions.c,80 :: 		result = -1; // Set result to -1 (TIMEOUT)
	MOVLW      255
	MOVWF      I2C_WriteEx_result_L0+0
	MOVLW      255
	MOVWF      I2C_WriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,81 :: 		goto _exitPoint;
	GOTO       ___I2C_WriteEx__exitPoint
;PIC16F_I2C_MasterFunctions.c,82 :: 		}
L_I2C_WriteEx8:
;PIC16F_I2C_MasterFunctions.c,86 :: 		}
L_I2C_WriteEx9:
;PIC16F_I2C_MasterFunctions.c,88 :: 		SSPCON2=SSPCON2|0b00000100; //PEN bit = 1;
	BSF        SSPCON2+0, 2
;PIC16F_I2C_MasterFunctions.c,89 :: 		result = -2; // Set result to -2 (Not Acknowledged)
	MOVLW      254
	MOVWF      I2C_WriteEx_result_L0+0
	MOVLW      255
	MOVWF      I2C_WriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,91 :: 		_exitPoint:
___I2C_WriteEx__exitPoint:
;PIC16F_I2C_MasterFunctions.c,92 :: 		return result;
	MOVF       I2C_WriteEx_result_L0+0, 0
	MOVWF      R0+0
	MOVF       I2C_WriteEx_result_L0+1, 0
	MOVWF      R0+1
;PIC16F_I2C_MasterFunctions.c,93 :: 		}
L_end_I2C_WriteEx:
	RETURN
; end of _I2C_WriteEx

_I2C_ReadEx:

;PIC16F_I2C_MasterFunctions.c,105 :: 		int I2C_ReadEx(char acknowledge, unsigned long timeout_us)
;PIC16F_I2C_MasterFunctions.c,107 :: 		int result = -1; // Set result to -1 (TIMEOUT)
	MOVLW      255
	MOVWF      I2C_ReadEx_result_L0+0
	MOVLW      255
	MOVWF      I2C_ReadEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,108 :: 		Delay_us(100);
	MOVLW      66
	MOVWF      R13+0
L_I2C_ReadEx10:
	DECFSZ     R13+0, 1
	GOTO       L_I2C_ReadEx10
	NOP
;PIC16F_I2C_MasterFunctions.c,109 :: 		PIR1 = PIR1&0b11110111;  //Reset SSPIF bit
	MOVLW      247
	ANDWF      PIR1+0, 1
;PIC16F_I2C_MasterFunctions.c,110 :: 		SSPCON2 = SSPCON2|0b00001000; //Enable receive mode
	BSF        SSPCON2+0, 3
;PIC16F_I2C_MasterFunctions.c,111 :: 		while(timeout_us>0 && !(PIR1&0b00001000)) //while(timeout not reached and no interrupt occured)
L_I2C_ReadEx11:
	MOVF       FARG_I2C_ReadEx_timeout_us+3, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx50
	MOVF       FARG_I2C_ReadEx_timeout_us+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx50
	MOVF       FARG_I2C_ReadEx_timeout_us+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx50
	MOVF       FARG_I2C_ReadEx_timeout_us+0, 0
	SUBLW      0
L__I2C_ReadEx50:
	BTFSC      STATUS+0, 0
	GOTO       L_I2C_ReadEx12
	BTFSC      PIR1+0, 3
	GOTO       L_I2C_ReadEx12
L__I2C_ReadEx43:
;PIC16F_I2C_MasterFunctions.c,113 :: 		timeout_us-=1;
	MOVLW      1
	SUBWF      FARG_I2C_ReadEx_timeout_us+0, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+1, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+2, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+3, 1
;PIC16F_I2C_MasterFunctions.c,114 :: 		if (!(PIR1&0b00001000)) //if(no interrupt occured)
	BTFSC      PIR1+0, 3
	GOTO       L_I2C_ReadEx15
;PIC16F_I2C_MasterFunctions.c,116 :: 		Delay_us(1);
	NOP
	NOP
;PIC16F_I2C_MasterFunctions.c,117 :: 		}
L_I2C_ReadEx15:
;PIC16F_I2C_MasterFunctions.c,118 :: 		}
	GOTO       L_I2C_ReadEx11
L_I2C_ReadEx12:
;PIC16F_I2C_MasterFunctions.c,119 :: 		if (timeout_us==0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_I2C_ReadEx_timeout_us+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx51
	MOVF       R0+0, 0
	XORWF      FARG_I2C_ReadEx_timeout_us+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx51
	MOVF       R0+0, 0
	XORWF      FARG_I2C_ReadEx_timeout_us+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx51
	MOVF       FARG_I2C_ReadEx_timeout_us+0, 0
	XORLW      0
L__I2C_ReadEx51:
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_ReadEx16
;PIC16F_I2C_MasterFunctions.c,121 :: 		PORTA=PORTA|0b00000100;
	BSF        PORTA+0, 2
;PIC16F_I2C_MasterFunctions.c,122 :: 		SSPCON2=SSPCON2|0b00000100; //PEN bit = 1;
	BSF        SSPCON2+0, 2
;PIC16F_I2C_MasterFunctions.c,123 :: 		}
	GOTO       L_I2C_ReadEx17
L_I2C_ReadEx16:
;PIC16F_I2C_MasterFunctions.c,126 :: 		result = SSPBUF;
	MOVF       SSPBUF+0, 0
	MOVWF      I2C_ReadEx_result_L0+0
	CLRF       I2C_ReadEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,127 :: 		}
L_I2C_ReadEx17:
;PIC16F_I2C_MasterFunctions.c,128 :: 		if (acknowledge==0)
	MOVF       FARG_I2C_ReadEx_acknowledge+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_ReadEx18
;PIC16F_I2C_MasterFunctions.c,130 :: 		SSPCON2 = SSPCON2|0b00100000;  // Set SSPCON2.ACKDT (Not Acknowledge)
	BSF        SSPCON2+0, 5
;PIC16F_I2C_MasterFunctions.c,131 :: 		}
	GOTO       L_I2C_ReadEx19
L_I2C_ReadEx18:
;PIC16F_I2C_MasterFunctions.c,134 :: 		SSPCON2 = SSPCON2&0b11011111; // Reset SSPCON2.ACKDT (Acknowledge)
	MOVLW      223
	ANDWF      SSPCON2+0, 1
;PIC16F_I2C_MasterFunctions.c,135 :: 		}
L_I2C_ReadEx19:
;PIC16F_I2C_MasterFunctions.c,136 :: 		PIR1 = PIR1&0b11110111;  //Reset SSPIF bit
	MOVLW      247
	ANDWF      PIR1+0, 1
;PIC16F_I2C_MasterFunctions.c,137 :: 		SSPCON2 = SSPCON2|0b00010000;  //Send ack/no ack back to slave
	BSF        SSPCON2+0, 4
;PIC16F_I2C_MasterFunctions.c,138 :: 		while(timeout_us>0 && !(PIR1&0b00001000))  //while(timeout not reached and no interrupt occured)
L_I2C_ReadEx20:
	MOVF       FARG_I2C_ReadEx_timeout_us+3, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx52
	MOVF       FARG_I2C_ReadEx_timeout_us+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx52
	MOVF       FARG_I2C_ReadEx_timeout_us+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx52
	MOVF       FARG_I2C_ReadEx_timeout_us+0, 0
	SUBLW      0
L__I2C_ReadEx52:
	BTFSC      STATUS+0, 0
	GOTO       L_I2C_ReadEx21
	BTFSC      PIR1+0, 3
	GOTO       L_I2C_ReadEx21
L__I2C_ReadEx42:
;PIC16F_I2C_MasterFunctions.c,140 :: 		timeout_us-=1;
	MOVLW      1
	SUBWF      FARG_I2C_ReadEx_timeout_us+0, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+1, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+2, 1
	BTFSS      STATUS+0, 0
	SUBWF      FARG_I2C_ReadEx_timeout_us+3, 1
;PIC16F_I2C_MasterFunctions.c,141 :: 		if (!(PIR1&0b00001000))  //if(no interrupt occured)
	BTFSC      PIR1+0, 3
	GOTO       L_I2C_ReadEx24
;PIC16F_I2C_MasterFunctions.c,143 :: 		Delay_us(1);
	NOP
	NOP
;PIC16F_I2C_MasterFunctions.c,144 :: 		}
L_I2C_ReadEx24:
;PIC16F_I2C_MasterFunctions.c,145 :: 		}
	GOTO       L_I2C_ReadEx20
L_I2C_ReadEx21:
;PIC16F_I2C_MasterFunctions.c,146 :: 		if (timeout_us==0)
	MOVLW      0
	MOVWF      R0+0
	XORWF      FARG_I2C_ReadEx_timeout_us+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx53
	MOVF       R0+0, 0
	XORWF      FARG_I2C_ReadEx_timeout_us+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx53
	MOVF       R0+0, 0
	XORWF      FARG_I2C_ReadEx_timeout_us+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_ReadEx53
	MOVF       FARG_I2C_ReadEx_timeout_us+0, 0
	XORLW      0
L__I2C_ReadEx53:
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_ReadEx25
;PIC16F_I2C_MasterFunctions.c,148 :: 		PORTA=PORTA|0b00001000;
	BSF        PORTA+0, 3
;PIC16F_I2C_MasterFunctions.c,149 :: 		SSPCON2=SSPCON2|0b00000100; //PEN bit = 1;
	BSF        SSPCON2+0, 2
;PIC16F_I2C_MasterFunctions.c,150 :: 		result = -1; // Set result to -1 (TIMEOUT)
	MOVLW      255
	MOVWF      I2C_ReadEx_result_L0+0
	MOVLW      255
	MOVWF      I2C_ReadEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,151 :: 		}
L_I2C_ReadEx25:
;PIC16F_I2C_MasterFunctions.c,152 :: 		return result;
	MOVF       I2C_ReadEx_result_L0+0, 0
	MOVWF      R0+0
	MOVF       I2C_ReadEx_result_L0+1, 0
	MOVWF      R0+1
;PIC16F_I2C_MasterFunctions.c,153 :: 		}
L_end_I2C_ReadEx:
	RETURN
; end of _I2C_ReadEx

_I2C_MasterWriteEx:

;PIC16F_I2C_MasterFunctions.c,167 :: 		int I2C_MasterWriteEx(unsigned char chipAddress, unsigned char slaveRegister, unsigned char input)
;PIC16F_I2C_MasterFunctions.c,169 :: 		int result = 0; // Set result to OK
	CLRF       I2C_MasterWriteEx_result_L0+0
	CLRF       I2C_MasterWriteEx_result_L0+1
	CLRF       I2C_MasterWriteEx_header_L0+0
;PIC16F_I2C_MasterFunctions.c,174 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,175 :: 		chipAddress = chipAddress<<1;
	MOVF       FARG_I2C_MasterWriteEx_chipAddress+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      FARG_I2C_MasterWriteEx_chipAddress+0
;PIC16F_I2C_MasterFunctions.c,176 :: 		I2C_WriteEx(chipAddress,_I2C_TIMEOUT);
	MOVF       R0+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,177 :: 		header = _HEADER_BIT;
	MOVLW      64
	MOVWF      I2C_MasterWriteEx_header_L0+0
;PIC16F_I2C_MasterFunctions.c,178 :: 		header = header | 0b10000000; // Inform the slave that two more requests will be received; If 6th bit is 0 then inform the slave that a logical write will be performed
	MOVLW      192
	MOVWF      I2C_MasterWriteEx_header_L0+0
;PIC16F_I2C_MasterFunctions.c,179 :: 		header = header | (slaveRegister & _SLAVE_MCU_REGISTER_MASK);
	MOVLW      31
	ANDWF      FARG_I2C_MasterWriteEx_slaveRegister+0, 0
	MOVWF      R0+0
	MOVLW      192
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_header_L0+0
;PIC16F_I2C_MasterFunctions.c,180 :: 		result = I2C_WriteEx(header,_I2C_TIMEOUT);
	MOVF       R0+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_result_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterWriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,181 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,183 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,184 :: 		I2C_WriteEx(chipAddress|1,_I2C_TIMEOUT); // A phisical read is requested
	MOVLW      1
	IORWF      FARG_I2C_MasterWriteEx_chipAddress+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,185 :: 		result = I2C_ReadEx(_NO_ACKANOWLEDGE,_I2C_TIMEOUT);
	CLRF       FARG_I2C_ReadEx_acknowledge+0
	MOVLW      200
	MOVWF      FARG_I2C_ReadEx_timeout_us+0
	CLRF       FARG_I2C_ReadEx_timeout_us+1
	CLRF       FARG_I2C_ReadEx_timeout_us+2
	CLRF       FARG_I2C_ReadEx_timeout_us+3
	CALL       _I2C_ReadEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_result_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterWriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,186 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,188 :: 		if (result>=0 && result == header) //The header was successfully transmitted to slave
	MOVLW      128
	XORWF      I2C_MasterWriteEx_result_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterWriteEx55
	MOVLW      0
	SUBWF      I2C_MasterWriteEx_result_L0+0, 0
L__I2C_MasterWriteEx55:
	BTFSS      STATUS+0, 0
	GOTO       L_I2C_MasterWriteEx28
	MOVLW      0
	XORWF      I2C_MasterWriteEx_result_L0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterWriteEx56
	MOVF       I2C_MasterWriteEx_header_L0+0, 0
	XORWF      I2C_MasterWriteEx_result_L0+0, 0
L__I2C_MasterWriteEx56:
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_MasterWriteEx28
L__I2C_MasterWriteEx45:
;PIC16F_I2C_MasterFunctions.c,190 :: 		for(count = 0; count<2; count++)
	CLRF       I2C_MasterWriteEx_count_L0+0
L_I2C_MasterWriteEx29:
	MOVLW      2
	SUBWF      I2C_MasterWriteEx_count_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_I2C_MasterWriteEx30
;PIC16F_I2C_MasterFunctions.c,192 :: 		if (count==0)
	MOVF       I2C_MasterWriteEx_count_L0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_I2C_MasterWriteEx32
;PIC16F_I2C_MasterFunctions.c,194 :: 		cdata = input&_MESSAGE_MASK;    // If 8th bit is 0 then the first 4 bites are writted
	MOVLW      15
	ANDWF      FARG_I2C_MasterWriteEx_input+0, 0
	MOVWF      I2C_MasterWriteEx_cdata_L0+0
;PIC16F_I2C_MasterFunctions.c,195 :: 		}
	GOTO       L_I2C_MasterWriteEx33
L_I2C_MasterWriteEx32:
;PIC16F_I2C_MasterFunctions.c,198 :: 		cdata = (input>>4)&_MESSAGE_MASK;
	MOVF       FARG_I2C_MasterWriteEx_input+0, 0
	MOVWF      I2C_MasterWriteEx_cdata_L0+0
	RRF        I2C_MasterWriteEx_cdata_L0+0, 1
	BCF        I2C_MasterWriteEx_cdata_L0+0, 7
	RRF        I2C_MasterWriteEx_cdata_L0+0, 1
	BCF        I2C_MasterWriteEx_cdata_L0+0, 7
	RRF        I2C_MasterWriteEx_cdata_L0+0, 1
	BCF        I2C_MasterWriteEx_cdata_L0+0, 7
	RRF        I2C_MasterWriteEx_cdata_L0+0, 1
	BCF        I2C_MasterWriteEx_cdata_L0+0, 7
	MOVLW      15
	ANDWF      I2C_MasterWriteEx_cdata_L0+0, 1
;PIC16F_I2C_MasterFunctions.c,199 :: 		cdata = cdata | 0b10000000;    // If 8th bit is 1 then the second 4 bites are writted
	BSF        I2C_MasterWriteEx_cdata_L0+0, 7
;PIC16F_I2C_MasterFunctions.c,200 :: 		}
L_I2C_MasterWriteEx33:
;PIC16F_I2C_MasterFunctions.c,201 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,202 :: 		result = I2C_WriteEx(chipAddress,_I2C_TIMEOUT);  // A phisical write is requested
	MOVF       FARG_I2C_MasterWriteEx_chipAddress+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_result_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterWriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,203 :: 		result = I2C_WriteEx(cdata,_I2C_TIMEOUT);
	MOVF       I2C_MasterWriteEx_cdata_L0+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_result_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterWriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,204 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,206 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,207 :: 		I2C_WriteEx(chipAddress|1,_I2C_TIMEOUT);  // A phisical read is requested
	MOVLW      1
	IORWF      FARG_I2C_MasterWriteEx_chipAddress+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,208 :: 		result = I2C_ReadEx(_NO_ACKANOWLEDGE,_I2C_TIMEOUT);
	CLRF       FARG_I2C_ReadEx_acknowledge+0
	MOVLW      200
	MOVWF      FARG_I2C_ReadEx_timeout_us+0
	CLRF       FARG_I2C_ReadEx_timeout_us+1
	CLRF       FARG_I2C_ReadEx_timeout_us+2
	CLRF       FARG_I2C_ReadEx_timeout_us+3
	CALL       _I2C_ReadEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterWriteEx_result_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterWriteEx_result_L0+1
;PIC16F_I2C_MasterFunctions.c,209 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,211 :: 		if (result<0 || result != cdata)
	MOVLW      128
	XORWF      I2C_MasterWriteEx_result_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterWriteEx57
	MOVLW      0
	SUBWF      I2C_MasterWriteEx_result_L0+0, 0
L__I2C_MasterWriteEx57:
	BTFSS      STATUS+0, 0
	GOTO       L__I2C_MasterWriteEx44
	MOVLW      0
	XORWF      I2C_MasterWriteEx_result_L0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterWriteEx58
	MOVF       I2C_MasterWriteEx_cdata_L0+0, 0
	XORWF      I2C_MasterWriteEx_result_L0+0, 0
L__I2C_MasterWriteEx58:
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterWriteEx44
	GOTO       L_I2C_MasterWriteEx36
L__I2C_MasterWriteEx44:
;PIC16F_I2C_MasterFunctions.c,213 :: 		break;
	GOTO       L_I2C_MasterWriteEx30
;PIC16F_I2C_MasterFunctions.c,214 :: 		}
L_I2C_MasterWriteEx36:
;PIC16F_I2C_MasterFunctions.c,190 :: 		for(count = 0; count<2; count++)
	INCF       I2C_MasterWriteEx_count_L0+0, 1
;PIC16F_I2C_MasterFunctions.c,215 :: 		}
	GOTO       L_I2C_MasterWriteEx29
L_I2C_MasterWriteEx30:
;PIC16F_I2C_MasterFunctions.c,216 :: 		}
L_I2C_MasterWriteEx28:
;PIC16F_I2C_MasterFunctions.c,217 :: 		return result;
	MOVF       I2C_MasterWriteEx_result_L0+0, 0
	MOVWF      R0+0
	MOVF       I2C_MasterWriteEx_result_L0+1, 0
	MOVWF      R0+1
;PIC16F_I2C_MasterFunctions.c,218 :: 		}
L_end_I2C_MasterWriteEx:
	RETURN
; end of _I2C_MasterWriteEx

_I2C_MasterReadEx:

;PIC16F_I2C_MasterFunctions.c,231 :: 		int I2C_MasterReadEx(unsigned char chipAddress, unsigned char slaveRegister)
;PIC16F_I2C_MasterFunctions.c,233 :: 		unsigned char result = 0;
	CLRF       I2C_MasterReadEx_result_L0+0
	CLRF       I2C_MasterReadEx_counter_L0+0
	CLRF       I2C_MasterReadEx_header_L0+0
	MOVLW      255
	MOVWF      I2C_MasterReadEx_tempResult_L0+0
	MOVLW      255
	MOVWF      I2C_MasterReadEx_tempResult_L0+1
;PIC16F_I2C_MasterFunctions.c,237 :: 		chipAddress = chipAddress<<1;
	RLF        FARG_I2C_MasterReadEx_chipAddress+0, 1
	BCF        FARG_I2C_MasterReadEx_chipAddress+0, 0
;PIC16F_I2C_MasterFunctions.c,238 :: 		for (counter=0; counter<2; counter++)
	CLRF       I2C_MasterReadEx_counter_L0+0
L_I2C_MasterReadEx37:
	MOVLW      2
	SUBWF      I2C_MasterReadEx_counter_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_I2C_MasterReadEx38
;PIC16F_I2C_MasterFunctions.c,240 :: 		header = counter<<_MSG_COUNT_SHIFT_NR_POS; // Write the message number to be readed from slave (a byte has 2 pair of 4 bites)
	MOVLW      7
	MOVWF      R0+0
	MOVF       I2C_MasterReadEx_counter_L0+0, 0
	MOVWF      I2C_MasterReadEx_header_L0+0
	MOVF       R0+0, 0
L__I2C_MasterReadEx60:
	BTFSC      STATUS+0, 2
	GOTO       L__I2C_MasterReadEx61
	RLF        I2C_MasterReadEx_header_L0+0, 1
	BCF        I2C_MasterReadEx_header_L0+0, 0
	ADDLW      255
	GOTO       L__I2C_MasterReadEx60
L__I2C_MasterReadEx61:
;PIC16F_I2C_MasterFunctions.c,241 :: 		header = header | _HEADER_BIT;
	BSF        I2C_MasterReadEx_header_L0+0, 6
;PIC16F_I2C_MasterFunctions.c,242 :: 		header = header | _HEADER_READ_REQUESTED;  // Logical read was requested from slave
	BSF        I2C_MasterReadEx_header_L0+0, 5
;PIC16F_I2C_MasterFunctions.c,243 :: 		header = header | (slaveRegister & _SLAVE_MCU_REGISTER_MASK);
	MOVLW      31
	ANDWF      FARG_I2C_MasterReadEx_slaveRegister+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	IORWF      I2C_MasterReadEx_header_L0+0, 1
;PIC16F_I2C_MasterFunctions.c,244 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,245 :: 		I2C_WriteEx(chipAddress,_I2C_TIMEOUT); // Phisical write was requested from slave
	MOVF       FARG_I2C_MasterReadEx_chipAddress+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,246 :: 		I2C_WriteEx(header,_I2C_TIMEOUT);
	MOVF       I2C_MasterReadEx_header_L0+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,247 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,248 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;PIC16F_I2C_MasterFunctions.c,249 :: 		I2C_WriteEx(chipAddress|1,_I2C_TIMEOUT); //Phisical read was requested from slave
	MOVLW      1
	IORWF      FARG_I2C_MasterReadEx_chipAddress+0, 0
	MOVWF      FARG_I2C_WriteEx_dat+0
	MOVLW      200
	MOVWF      FARG_I2C_WriteEx_timeout_us+0
	CLRF       FARG_I2C_WriteEx_timeout_us+1
	CLRF       FARG_I2C_WriteEx_timeout_us+2
	CLRF       FARG_I2C_WriteEx_timeout_us+3
	CALL       _I2C_WriteEx+0
;PIC16F_I2C_MasterFunctions.c,250 :: 		tempResult = I2C_ReadEx(_NO_ACKANOWLEDGE,_I2C_TIMEOUT);
	CLRF       FARG_I2C_ReadEx_acknowledge+0
	MOVLW      200
	MOVWF      FARG_I2C_ReadEx_timeout_us+0
	CLRF       FARG_I2C_ReadEx_timeout_us+1
	CLRF       FARG_I2C_ReadEx_timeout_us+2
	CLRF       FARG_I2C_ReadEx_timeout_us+3
	CALL       _I2C_ReadEx+0
	MOVF       R0+0, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+1
;PIC16F_I2C_MasterFunctions.c,251 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;PIC16F_I2C_MasterFunctions.c,252 :: 		if (tempResult<0) // An error was encountered in transmission
	MOVLW      128
	XORWF      I2C_MasterReadEx_tempResult_L0+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__I2C_MasterReadEx62
	MOVLW      0
	SUBWF      I2C_MasterReadEx_tempResult_L0+0, 0
L__I2C_MasterReadEx62:
	BTFSC      STATUS+0, 0
	GOTO       L_I2C_MasterReadEx40
;PIC16F_I2C_MasterFunctions.c,254 :: 		result = tempResult;
	MOVF       I2C_MasterReadEx_tempResult_L0+0, 0
	MOVWF      I2C_MasterReadEx_result_L0+0
;PIC16F_I2C_MasterFunctions.c,255 :: 		return;
	GOTO       L_end_I2C_MasterReadEx
;PIC16F_I2C_MasterFunctions.c,256 :: 		}
L_I2C_MasterReadEx40:
;PIC16F_I2C_MasterFunctions.c,259 :: 		tempResult = tempResult & _MESSAGE_MASK;
	MOVLW      15
	ANDWF      I2C_MasterReadEx_tempResult_L0+0, 0
	MOVWF      R3+0
	MOVF       I2C_MasterReadEx_tempResult_L0+1, 0
	MOVWF      R3+1
	MOVLW      0
	ANDWF      R3+1, 1
	MOVF       R3+0, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+0
	MOVF       R3+1, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+1
;PIC16F_I2C_MasterFunctions.c,260 :: 		tempResult = tempResult << (counter * 4);
	MOVF       I2C_MasterReadEx_counter_L0+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R3+0, 0
	MOVWF      R0+0
	MOVF       R3+1, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__I2C_MasterReadEx63:
	BTFSC      STATUS+0, 2
	GOTO       L__I2C_MasterReadEx64
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__I2C_MasterReadEx63
L__I2C_MasterReadEx64:
	MOVF       R0+0, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+0
	MOVF       R0+1, 0
	MOVWF      I2C_MasterReadEx_tempResult_L0+1
;PIC16F_I2C_MasterFunctions.c,261 :: 		result = result | tempResult;
	MOVF       R0+0, 0
	IORWF      I2C_MasterReadEx_result_L0+0, 1
;PIC16F_I2C_MasterFunctions.c,238 :: 		for (counter=0; counter<2; counter++)
	INCF       I2C_MasterReadEx_counter_L0+0, 1
;PIC16F_I2C_MasterFunctions.c,263 :: 		}
	GOTO       L_I2C_MasterReadEx37
L_I2C_MasterReadEx38:
;PIC16F_I2C_MasterFunctions.c,264 :: 		return result;
	MOVF       I2C_MasterReadEx_result_L0+0, 0
	MOVWF      R0+0
	CLRF       R0+1
;PIC16F_I2C_MasterFunctions.c,265 :: 		}
L_end_I2C_MasterReadEx:
	RETURN
; end of _I2C_MasterReadEx
