
_PrepareResponseData:

;PIC16F887_I2CSlaveHelpers.c,54 :: 		unsigned char PrepareResponseData(unsigned char input)
;PIC16F887_I2CSlaveHelpers.c,56 :: 		unsigned char result = 0;
	CLRF       PrepareResponseData_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,59 :: 		receivedMessageCount =  input >> _MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_PrepareResponseData_input+0, 0
	MOVWF      R8+0
	MOVF       R0+0, 0
L__PrepareResponseData53:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData54
	RRF        R8+0, 1
	BCF        R8+0, 7
	ADDLW      255
	GOTO       L__PrepareResponseData53
L__PrepareResponseData54:
;PIC16F887_I2CSlaveHelpers.c,60 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_PrepareResponseData2
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PrepareResponseData2
L__PrepareResponseData43:
;PIC16F887_I2CSlaveHelpers.c,62 :: 		tempVariable = ucI2CRegisters[cI2CCurrentRegisterNumber];
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R9+0
	CLRF       R9+1
	CLRF       R9+2
	CLRF       R9+3
	MOVLW      0
	MOVWF      R9+1
	MOVWF      R9+2
	MOVWF      R9+3
;PIC16F887_I2CSlaveHelpers.c,63 :: 		tempVariable = tempVariable>>(receivedMessageCount*4);
	MOVF       R8+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      R4+0
	MOVF       R9+0, 0
	MOVWF      R0+0
	MOVF       R9+1, 0
	MOVWF      R0+1
	MOVF       R9+2, 0
	MOVWF      R0+2
	MOVF       R9+3, 0
	MOVWF      R0+3
	MOVF       R4+0, 0
L__PrepareResponseData55:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData56
	RRF        R0+3, 1
	RRF        R0+2, 1
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+3, 7
	ADDLW      255
	GOTO       L__PrepareResponseData55
L__PrepareResponseData56:
	MOVF       R0+0, 0
	MOVWF      R9+0
	MOVF       R0+1, 0
	MOVWF      R9+1
	MOVF       R0+2, 0
	MOVWF      R9+2
	MOVF       R0+3, 0
	MOVWF      R9+3
;PIC16F887_I2CSlaveHelpers.c,64 :: 		tempVariable = tempVariable&0x0F;
	MOVLW      15
	ANDWF      R0+0, 0
	MOVWF      R4+0
	MOVF       R0+1, 0
	MOVWF      R4+1
	MOVF       R0+2, 0
	MOVWF      R4+2
	MOVF       R0+3, 0
	MOVWF      R4+3
	MOVLW      0
	ANDWF      R4+1, 1
	ANDWF      R4+2, 1
	ANDWF      R4+3, 1
	MOVF       R4+0, 0
	MOVWF      R9+0
	MOVF       R4+1, 0
	MOVWF      R9+1
	MOVF       R4+2, 0
	MOVWF      R9+2
	MOVF       R4+3, 0
	MOVWF      R9+3
;PIC16F887_I2CSlaveHelpers.c,65 :: 		tempVariable = tempVariable | (receivedMessageCount<<_MSG_COUNT_SHIFT_NR_POS);
	MOVLW      7
	MOVWF      R2+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       R2+0, 0
L__PrepareResponseData57:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData58
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__PrepareResponseData57
L__PrepareResponseData58:
	MOVLW      0
	MOVWF      R0+2
	MOVWF      R0+3
	MOVF       R4+0, 0
	IORWF      R0+0, 1
	MOVF       R4+1, 0
	IORWF      R0+1, 1
	MOVF       R4+2, 0
	IORWF      R0+2, 1
	MOVF       R4+3, 0
	IORWF      R0+3, 1
	MOVF       R0+0, 0
	MOVWF      R9+0
	MOVF       R0+1, 0
	MOVWF      R9+1
	MOVF       R0+2, 0
	MOVWF      R9+2
	MOVF       R0+3, 0
	MOVWF      R9+3
;PIC16F887_I2CSlaveHelpers.c,66 :: 		result = tempVariable;
	MOVF       R0+0, 0
	MOVWF      PrepareResponseData_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,67 :: 		}
L_PrepareResponseData2:
;PIC16F887_I2CSlaveHelpers.c,68 :: 		return result;
	MOVF       PrepareResponseData_result_L0+0, 0
	MOVWF      R0+0
;PIC16F887_I2CSlaveHelpers.c,69 :: 		}
L_end_PrepareResponseData:
	RETURN
; end of _PrepareResponseData

_ParseI2CHeader:

;PIC16F887_I2CSlaveHelpers.c,85 :: 		char ParseI2CHeader(unsigned char input)
;PIC16F887_I2CSlaveHelpers.c,87 :: 		char result = -1; // Set result as invalid header
	MOVLW      255
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,88 :: 		if (input & 0b01000000)
	BTFSS      FARG_ParseI2CHeader_input+0, 6
	GOTO       L_ParseI2CHeader3
;PIC16F887_I2CSlaveHelpers.c,90 :: 		cI2CCurrentRegisterNumber = input&0b00011111;
	MOVLW      31
	ANDWF      FARG_ParseI2CHeader_input+0, 0
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F887_I2CSlaveHelpers.c,91 :: 		cI2CR_W_Operation = input&0b00100000;
	MOVLW      32
	ANDWF      FARG_ParseI2CHeader_input+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _cI2CR_W_Operation+0
;PIC16F887_I2CSlaveHelpers.c,92 :: 		if (input&0b00100000)
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_ParseI2CHeader4
;PIC16F887_I2CSlaveHelpers.c,94 :: 		cI2CR_W_Operation = _I2C_WRITE;
	MOVLW      __I2C_WRITE
	MOVWF      _cI2CR_W_Operation+0
;PIC16F887_I2CSlaveHelpers.c,95 :: 		cI2CData = PrepareResponseData(input);
	MOVF       FARG_ParseI2CHeader_input+0, 0
	MOVWF      FARG_PrepareResponseData_input+0
	CALL       _PrepareResponseData+0
	MOVF       R0+0, 0
	MOVWF      _cI2CData+0
;PIC16F887_I2CSlaveHelpers.c,96 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,97 :: 		}
	GOTO       L_ParseI2CHeader5
L_ParseI2CHeader4:
;PIC16F887_I2CSlaveHelpers.c,100 :: 		cI2CR_W_Operation = _I2C_READ;
	MOVLW      __I2C_READ
	MOVWF      _cI2CR_W_Operation+0
;PIC16F887_I2CSlaveHelpers.c,101 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CHeader8
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CHeader8
L__ParseI2CHeader44:
;PIC16F887_I2CSlaveHelpers.c,103 :: 		ucI2CCurrentStatus = _I2C_STATUS_STARTED;
	MOVLW      __I2C_STATUS_STARTED
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,104 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_STARTED;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_STARTED
	MOVWF      INDF+0
;PIC16F887_I2CSlaveHelpers.c,105 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	CLRF       INDF+0
;PIC16F887_I2CSlaveHelpers.c,106 :: 		cI2CTotalMsgCount = input>>_MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_ParseI2CHeader_input+0, 0
	MOVWF      _cI2CTotalMsgCount+0
	MOVF       R0+0, 0
L__ParseI2CHeader60:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CHeader61
	RRF        _cI2CTotalMsgCount+0, 1
	BCF        _cI2CTotalMsgCount+0, 7
	ADDLW      255
	GOTO       L__ParseI2CHeader60
L__ParseI2CHeader61:
;PIC16F887_I2CSlaveHelpers.c,107 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,108 :: 		}
L_ParseI2CHeader8:
;PIC16F887_I2CSlaveHelpers.c,109 :: 		}
L_ParseI2CHeader5:
;PIC16F887_I2CSlaveHelpers.c,110 :: 		}
L_ParseI2CHeader3:
;PIC16F887_I2CSlaveHelpers.c,111 :: 		return result;
	MOVF       ParseI2CHeader_result_L0+0, 0
	MOVWF      R0+0
;PIC16F887_I2CSlaveHelpers.c,112 :: 		}
L_end_ParseI2CHeader:
	RETURN
; end of _ParseI2CHeader

_ParseI2CData:

;PIC16F887_I2CSlaveHelpers.c,127 :: 		char ParseI2CData(unsigned char input)
;PIC16F887_I2CSlaveHelpers.c,129 :: 		char result = -1; // Set result as invalid data
	MOVLW      255
	MOVWF      ParseI2CData_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,132 :: 		if (input & 0b01000000)
	BTFSS      FARG_ParseI2CData_input+0, 6
	GOTO       L_ParseI2CData9
;PIC16F887_I2CSlaveHelpers.c,134 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,135 :: 		}
	GOTO       L_ParseI2CData10
L_ParseI2CData9:
;PIC16F887_I2CSlaveHelpers.c,138 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CData13
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CData13
L__ParseI2CData46:
;PIC16F887_I2CSlaveHelpers.c,140 :: 		mask = input & 0b00001111;
	MOVLW      15
	ANDWF      FARG_ParseI2CData_input+0, 0
	MOVWF      R5+0
	CLRF       R5+1
	MOVLW      0
	ANDWF      R5+1, 1
	MOVLW      0
	MOVWF      R5+1
	MOVWF      R5+2
	MOVWF      R5+3
;PIC16F887_I2CSlaveHelpers.c,141 :: 		receivedMessageCount =  input >> _MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_ParseI2CData_input+0, 0
	MOVWF      R1+0
	MOVF       R0+0, 0
L__ParseI2CData63:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CData64
	RRF        R1+0, 1
	BCF        R1+0, 7
	ADDLW      255
	GOTO       L__ParseI2CData63
L__ParseI2CData64:
;PIC16F887_I2CSlaveHelpers.c,142 :: 		cI2CCurrentMsgCount+=1;
	INCF       _cI2CCurrentMsgCount+0, 1
;PIC16F887_I2CSlaveHelpers.c,143 :: 		if (receivedMessageCount!=cI2CCurrentMsgCount || cI2CCurrentMsgCount > cI2CTotalMsgCount)
	MOVF       R1+0, 0
	XORWF      _cI2CCurrentMsgCount+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ParseI2CData45
	MOVF       _cI2CCurrentMsgCount+0, 0
	SUBWF      _cI2CTotalMsgCount+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__ParseI2CData45
	GOTO       L_ParseI2CData16
L__ParseI2CData45:
;PIC16F887_I2CSlaveHelpers.c,145 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,146 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_ERROR;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      INDF+0
;PIC16F887_I2CSlaveHelpers.c,147 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	CLRF       INDF+0
;PIC16F887_I2CSlaveHelpers.c,148 :: 		cI2CCurrentRegisterNumber = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F887_I2CSlaveHelpers.c,149 :: 		cI2CTotalMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CTotalMsgCount+0
;PIC16F887_I2CSlaveHelpers.c,150 :: 		cI2CCurrentMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentMsgCount+0
;PIC16F887_I2CSlaveHelpers.c,151 :: 		}
	GOTO       L_ParseI2CData17
L_ParseI2CData16:
;PIC16F887_I2CSlaveHelpers.c,154 :: 		mask = mask<<(4*cI2CCurrentMsgCount);
	MOVF       _cI2CCurrentMsgCount+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      R4+0
	MOVF       R5+0, 0
	MOVWF      R0+0
	MOVF       R5+1, 0
	MOVWF      R0+1
	MOVF       R5+2, 0
	MOVWF      R0+2
	MOVF       R5+3, 0
	MOVWF      R0+3
	MOVF       R4+0, 0
L__ParseI2CData65:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CData66
	RLF        R0+0, 1
	RLF        R0+1, 1
	RLF        R0+2, 1
	RLF        R0+3, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__ParseI2CData65
L__ParseI2CData66:
	MOVF       R0+0, 0
	MOVWF      R5+0
	MOVF       R0+1, 0
	MOVWF      R5+1
	MOVF       R0+2, 0
	MOVWF      R5+2
	MOVF       R0+3, 0
	MOVWF      R5+3
;PIC16F887_I2CSlaveHelpers.c,155 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = ucI2CRegisters[cI2CCurrentRegisterNumber] | mask;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      R4+0
	MOVF       R4+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R4+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;PIC16F887_I2CSlaveHelpers.c,156 :: 		if (cI2CCurrentMsgCount < cI2CTotalMsgCount)
	MOVF       _cI2CTotalMsgCount+0, 0
	SUBWF      _cI2CCurrentMsgCount+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CData18
;PIC16F887_I2CSlaveHelpers.c,158 :: 		ucI2CCurrentStatus = _I2C_STATUS_INPROGRESS;
	MOVLW      __I2C_STATUS_INPROGRESS
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,159 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_INPROGRESS;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_INPROGRESS
	MOVWF      INDF+0
;PIC16F887_I2CSlaveHelpers.c,160 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CData_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,161 :: 		}
	GOTO       L_ParseI2CData19
L_ParseI2CData18:
;PIC16F887_I2CSlaveHelpers.c,162 :: 		else if (cI2CCurrentMsgCount == cI2CTotalMsgCount)
	MOVF       _cI2CCurrentMsgCount+0, 0
	XORWF      _cI2CTotalMsgCount+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_ParseI2CData20
;PIC16F887_I2CSlaveHelpers.c,164 :: 		ucI2CCurrentStatus = _I2C_STATUS_END;
	MOVLW      __I2C_STATUS_END
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,165 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_END;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_END
	MOVWF      INDF+0
;PIC16F887_I2CSlaveHelpers.c,166 :: 		cI2CCurrentRegisterNumber = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F887_I2CSlaveHelpers.c,167 :: 		cI2CTotalMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CTotalMsgCount+0
;PIC16F887_I2CSlaveHelpers.c,168 :: 		cI2CCurrentMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentMsgCount+0
;PIC16F887_I2CSlaveHelpers.c,169 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CData_result_L0+0
;PIC16F887_I2CSlaveHelpers.c,170 :: 		}
L_ParseI2CData20:
L_ParseI2CData19:
;PIC16F887_I2CSlaveHelpers.c,171 :: 		}
L_ParseI2CData17:
;PIC16F887_I2CSlaveHelpers.c,172 :: 		}
L_ParseI2CData13:
;PIC16F887_I2CSlaveHelpers.c,173 :: 		}
L_ParseI2CData10:
;PIC16F887_I2CSlaveHelpers.c,174 :: 		return result;
	MOVF       ParseI2CData_result_L0+0, 0
	MOVWF      R0+0
;PIC16F887_I2CSlaveHelpers.c,175 :: 		}
L_end_ParseI2CData:
	RETURN
; end of _ParseI2CData

_ParseI2CInput:

;PIC16F887_I2CSlaveHelpers.c,189 :: 		void ParseI2CInput(unsigned char input)
;PIC16F887_I2CSlaveHelpers.c,191 :: 		if (ucI2CCurrentStatus == _I2C_STATUS_IDLE || ucI2CCurrentStatus == _I2C_STATUS_ERROR || ucI2CCurrentStatus == _I2C_STATUS_END)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_IDLE
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput51
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_ERROR
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput51
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_END
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput51
	GOTO       L_ParseI2CInput23
L__ParseI2CInput51:
;PIC16F887_I2CSlaveHelpers.c,193 :: 		ParseI2CHeader(input);
	MOVF       FARG_ParseI2CInput_input+0, 0
	MOVWF      FARG_ParseI2CHeader_input+0
	CALL       _ParseI2CHeader+0
;PIC16F887_I2CSlaveHelpers.c,194 :: 		}
	GOTO       L_ParseI2CInput24
L_ParseI2CInput23:
;PIC16F887_I2CSlaveHelpers.c,195 :: 		else if (ucI2CCurrentStatus == _I2C_STATUS_STARTED || ucI2CCurrentStatus == _I2C_STATUS_INPROGRESS)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_STARTED
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput50
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_INPROGRESS
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput50
	GOTO       L_ParseI2CInput27
L__ParseI2CInput50:
;PIC16F887_I2CSlaveHelpers.c,197 :: 		if ((cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CInput34
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CInput34
;PIC16F887_I2CSlaveHelpers.c,198 :: 		&&(ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_STARTED || ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_INPROGRESS))
L__ParseI2CInput49:
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      __I2C_STATUS_STARTED
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput48
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      __I2C_STATUS_INPROGRESS
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput48
	GOTO       L_ParseI2CInput34
L__ParseI2CInput48:
L__ParseI2CInput47:
;PIC16F887_I2CSlaveHelpers.c,200 :: 		ParseI2CData(input);
	MOVF       FARG_ParseI2CInput_input+0, 0
	MOVWF      FARG_ParseI2CData_input+0
	CALL       _ParseI2CData+0
;PIC16F887_I2CSlaveHelpers.c,201 :: 		}
	GOTO       L_ParseI2CInput35
L_ParseI2CInput34:
;PIC16F887_I2CSlaveHelpers.c,204 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,205 :: 		}
L_ParseI2CInput35:
;PIC16F887_I2CSlaveHelpers.c,206 :: 		}
L_ParseI2CInput27:
L_ParseI2CInput24:
;PIC16F887_I2CSlaveHelpers.c,207 :: 		if (ucI2CCurrentStatus == _I2C_STATUS_END)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_END
	BTFSS      STATUS+0, 2
	GOTO       L_ParseI2CInput36
;PIC16F887_I2CSlaveHelpers.c,209 :: 		ucI2CCurrentStatus = _I2C_STATUS_IDLE;
	MOVLW      __I2C_STATUS_IDLE
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F887_I2CSlaveHelpers.c,210 :: 		}
L_ParseI2CInput36:
;PIC16F887_I2CSlaveHelpers.c,211 :: 		}
L_end_ParseI2CInput:
	RETURN
; end of _ParseI2CInput

_ManageI2CBus:

;PIC16F887_I2CSlaveHelpers.c,224 :: 		void ManageI2CBus()
;PIC16F887_I2CSlaveHelpers.c,226 :: 		if (SSPSTAT.R_W == _I2C_WRITE) //The W/R bit (0) indicate a write
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 2
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_WRITE
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus37
;PIC16F887_I2CSlaveHelpers.c,230 :: 		if (SSPSTAT.D_A == _I2C_ADDRESS) //The last received byte was an address
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_ADDRESS
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus38
;PIC16F887_I2CSlaveHelpers.c,234 :: 		cI2CAddress = SSPBUF;
	MOVF       SSPBUF+0, 0
	MOVWF      _cI2CAddress+0
;PIC16F887_I2CSlaveHelpers.c,235 :: 		SSPSTAT.BF = 0;                    // Reset flag Buffer-Full
	BCF        SSPSTAT+0, 0
;PIC16F887_I2CSlaveHelpers.c,236 :: 		}
	GOTO       L_ManageI2CBus39
L_ManageI2CBus38:
;PIC16F887_I2CSlaveHelpers.c,241 :: 		cI2CData = SSPBUF;                    // Read data from SSPBUF
	MOVF       SSPBUF+0, 0
	MOVWF      _cI2CData+0
;PIC16F887_I2CSlaveHelpers.c,243 :: 		ParseI2CInput(cI2CData);
	MOVF       _cI2CData+0, 0
	MOVWF      FARG_ParseI2CInput_input+0
	CALL       _ParseI2CInput+0
;PIC16F887_I2CSlaveHelpers.c,244 :: 		}
L_ManageI2CBus39:
;PIC16F887_I2CSlaveHelpers.c,245 :: 		}
	GOTO       L_ManageI2CBus40
L_ManageI2CBus37:
;PIC16F887_I2CSlaveHelpers.c,249 :: 		if (SSPSTAT.D_A == _I2C_ADDRESS) //The last received byte was an address
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_ADDRESS
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus41
;PIC16F887_I2CSlaveHelpers.c,253 :: 		SSPBUF = cI2CData;                    // Write data from cI2CData to SSPBUF
	MOVF       _cI2CData+0, 0
	MOVWF      SSPBUF+0
;PIC16F887_I2CSlaveHelpers.c,254 :: 		}
	GOTO       L_ManageI2CBus42
L_ManageI2CBus41:
;PIC16F887_I2CSlaveHelpers.c,259 :: 		SSPBUF = cI2CAddress;              // Respond with this chip address
	MOVF       _cI2CAddress+0, 0
	MOVWF      SSPBUF+0
;PIC16F887_I2CSlaveHelpers.c,260 :: 		}
L_ManageI2CBus42:
;PIC16F887_I2CSlaveHelpers.c,261 :: 		}
L_ManageI2CBus40:
;PIC16F887_I2CSlaveHelpers.c,262 :: 		SSPCON.CKP = 1;                       // Allow clock stretching
	BSF        SSPCON+0, 4
;PIC16F887_I2CSlaveHelpers.c,263 :: 		PIR1.SSPIF = 0;                       // Reset SSP-Interrupt-Flag
	BCF        PIR1+0, 3
;PIC16F887_I2CSlaveHelpers.c,264 :: 		}
L_end_ManageI2CBus:
	RETURN
; end of _ManageI2CBus
