
_PrepareResponseData:

;PIC16F_I2C_SlaveFunctions.c,77 :: 		unsigned char PrepareResponseData(unsigned char input)
;PIC16F_I2C_SlaveFunctions.c,79 :: 		unsigned char result = 0;
	CLRF       PrepareResponseData_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,82 :: 		receivedMessageCount =  input >> _MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_PrepareResponseData_input+0, 0
	MOVWF      R4+0
	MOVF       R0+0, 0
L__PrepareResponseData56:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData57
	RRF        R4+0, 1
	BCF        R4+0, 7
	ADDLW      255
	GOTO       L__PrepareResponseData56
L__PrepareResponseData57:
;PIC16F_I2C_SlaveFunctions.c,83 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_PrepareResponseData2
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PrepareResponseData2
L__PrepareResponseData46:
;PIC16F_I2C_SlaveFunctions.c,85 :: 		tempVariable = ucI2CRegisters[cI2CCurrentRegisterNumber];
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R3+0
;PIC16F_I2C_SlaveFunctions.c,86 :: 		tempVariable = tempVariable>>(receivedMessageCount*4);
	MOVF       R4+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R3+0, 0
	MOVWF      PrepareResponseData_result_L0+0
	MOVF       R0+0, 0
L__PrepareResponseData58:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData59
	RRF        PrepareResponseData_result_L0+0, 1
	BCF        PrepareResponseData_result_L0+0, 7
	ADDLW      255
	GOTO       L__PrepareResponseData58
L__PrepareResponseData59:
;PIC16F_I2C_SlaveFunctions.c,87 :: 		tempVariable = tempVariable&_MESSAGE_MASK;
	MOVLW      15
	ANDWF      PrepareResponseData_result_L0+0, 1
;PIC16F_I2C_SlaveFunctions.c,88 :: 		tempVariable = tempVariable | (receivedMessageCount<<_MSG_COUNT_SHIFT_NR_POS);
	MOVLW      7
	MOVWF      R1+0
	MOVF       R4+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
L__PrepareResponseData60:
	BTFSC      STATUS+0, 2
	GOTO       L__PrepareResponseData61
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__PrepareResponseData60
L__PrepareResponseData61:
	MOVF       R0+0, 0
	IORWF      PrepareResponseData_result_L0+0, 1
;PIC16F_I2C_SlaveFunctions.c,89 :: 		result = tempVariable;
;PIC16F_I2C_SlaveFunctions.c,90 :: 		}
L_PrepareResponseData2:
;PIC16F_I2C_SlaveFunctions.c,91 :: 		return result;
	MOVF       PrepareResponseData_result_L0+0, 0
	MOVWF      R0+0
;PIC16F_I2C_SlaveFunctions.c,92 :: 		}
L_end_PrepareResponseData:
	RETURN
; end of _PrepareResponseData

_ParseI2CHeader:

;PIC16F_I2C_SlaveFunctions.c,108 :: 		char ParseI2CHeader(unsigned char input)
;PIC16F_I2C_SlaveFunctions.c,110 :: 		char result = -1; // Set result as invalid header
	MOVLW      255
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,111 :: 		if (input & _HEADER_BIT)
	BTFSS      FARG_ParseI2CHeader_input+0, 6
	GOTO       L_ParseI2CHeader3
;PIC16F_I2C_SlaveFunctions.c,113 :: 		cI2CCurrentRegisterNumber = input&_SLAVE_MCU_REGISTER_MASK; // Set current register where the operation will be performed
	MOVLW      31
	ANDWF      FARG_ParseI2CHeader_input+0, 0
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F_I2C_SlaveFunctions.c,114 :: 		cI2CR_W_Operation = input&_HEADER_READ_REQUESTED; // Set logical read/write
	MOVLW      32
	ANDWF      FARG_ParseI2CHeader_input+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _cI2CR_W_Operation+0
;PIC16F_I2C_SlaveFunctions.c,115 :: 		if (input&_HEADER_READ_REQUESTED) //If logical read was requested
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_ParseI2CHeader4
;PIC16F_I2C_SlaveFunctions.c,117 :: 		cI2CData = PrepareResponseData(input);
	MOVF       FARG_ParseI2CHeader_input+0, 0
	MOVWF      FARG_PrepareResponseData_input+0
	CALL       _PrepareResponseData+0
	MOVF       R0+0, 0
	MOVWF      _cI2CData+0
;PIC16F_I2C_SlaveFunctions.c,118 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,119 :: 		}
	GOTO       L_ParseI2CHeader5
L_ParseI2CHeader4:
;PIC16F_I2C_SlaveFunctions.c,122 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CHeader8
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CHeader8
L__ParseI2CHeader47:
;PIC16F_I2C_SlaveFunctions.c,124 :: 		ucI2CCurrentStatus = _I2C_STATUS_STARTED;
	MOVLW      __I2C_STATUS_STARTED
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,125 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_STARTED;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_STARTED
	MOVWF      INDF+0
;PIC16F_I2C_SlaveFunctions.c,126 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	CLRF       INDF+0
;PIC16F_I2C_SlaveFunctions.c,127 :: 		cI2CTotalMsgCount = input>>_MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_ParseI2CHeader_input+0, 0
	MOVWF      _cI2CTotalMsgCount+0
	MOVF       R0+0, 0
L__ParseI2CHeader63:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CHeader64
	RRF        _cI2CTotalMsgCount+0, 1
	BCF        _cI2CTotalMsgCount+0, 7
	ADDLW      255
	GOTO       L__ParseI2CHeader63
L__ParseI2CHeader64:
;PIC16F_I2C_SlaveFunctions.c,128 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CHeader_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,129 :: 		}
L_ParseI2CHeader8:
;PIC16F_I2C_SlaveFunctions.c,130 :: 		}
L_ParseI2CHeader5:
;PIC16F_I2C_SlaveFunctions.c,131 :: 		}
L_ParseI2CHeader3:
;PIC16F_I2C_SlaveFunctions.c,132 :: 		return result;
	MOVF       ParseI2CHeader_result_L0+0, 0
	MOVWF      R0+0
;PIC16F_I2C_SlaveFunctions.c,133 :: 		}
L_end_ParseI2CHeader:
	RETURN
; end of _ParseI2CHeader

_ParseI2CData:

;PIC16F_I2C_SlaveFunctions.c,148 :: 		char ParseI2CData(unsigned char input)
;PIC16F_I2C_SlaveFunctions.c,150 :: 		char result = -1; // Set result as invalid data
	MOVLW      255
	MOVWF      ParseI2CData_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,153 :: 		if (input & _HEADER_BIT)
	BTFSS      FARG_ParseI2CData_input+0, 6
	GOTO       L_ParseI2CData9
;PIC16F_I2C_SlaveFunctions.c,155 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,156 :: 		}
	GOTO       L_ParseI2CData10
L_ParseI2CData9:
;PIC16F_I2C_SlaveFunctions.c,159 :: 		if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CData13
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CData13
L__ParseI2CData49:
;PIC16F_I2C_SlaveFunctions.c,161 :: 		mask = input & _MESSAGE_MASK;
	MOVLW      15
	ANDWF      FARG_ParseI2CData_input+0, 0
	MOVWF      R2+0
;PIC16F_I2C_SlaveFunctions.c,162 :: 		receivedMessageCount =  input >> _MSG_COUNT_SHIFT_NR_POS;
	MOVLW      7
	MOVWF      R0+0
	MOVF       FARG_ParseI2CData_input+0, 0
	MOVWF      R1+0
	MOVF       R0+0, 0
L__ParseI2CData66:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CData67
	RRF        R1+0, 1
	BCF        R1+0, 7
	ADDLW      255
	GOTO       L__ParseI2CData66
L__ParseI2CData67:
;PIC16F_I2C_SlaveFunctions.c,163 :: 		cI2CCurrentMsgCount+=1;
	INCF       _cI2CCurrentMsgCount+0, 1
;PIC16F_I2C_SlaveFunctions.c,164 :: 		if (receivedMessageCount!=cI2CCurrentMsgCount || cI2CCurrentMsgCount > cI2CTotalMsgCount)
	MOVF       R1+0, 0
	XORWF      _cI2CCurrentMsgCount+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ParseI2CData48
	MOVF       _cI2CCurrentMsgCount+0, 0
	SUBWF      _cI2CTotalMsgCount+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__ParseI2CData48
	GOTO       L_ParseI2CData16
L__ParseI2CData48:
;PIC16F_I2C_SlaveFunctions.c,166 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,167 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_ERROR;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      INDF+0
;PIC16F_I2C_SlaveFunctions.c,168 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	CLRF       INDF+0
;PIC16F_I2C_SlaveFunctions.c,169 :: 		cI2CCurrentRegisterNumber = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F_I2C_SlaveFunctions.c,170 :: 		cI2CTotalMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CTotalMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,171 :: 		cI2CCurrentMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,172 :: 		}
	GOTO       L_ParseI2CData17
L_ParseI2CData16:
;PIC16F_I2C_SlaveFunctions.c,175 :: 		mask = mask<<(4*cI2CCurrentMsgCount);
	MOVF       _cI2CCurrentMsgCount+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      R1+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
L__ParseI2CData68:
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CData69
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__ParseI2CData68
L__ParseI2CData69:
	MOVF       R0+0, 0
	MOVWF      R2+0
;PIC16F_I2C_SlaveFunctions.c,176 :: 		ucI2CRegisters[cI2CCurrentRegisterNumber] = ucI2CRegisters[cI2CCurrentRegisterNumber] | mask;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;PIC16F_I2C_SlaveFunctions.c,177 :: 		if (cI2CCurrentMsgCount < cI2CTotalMsgCount)
	MOVF       _cI2CTotalMsgCount+0, 0
	SUBWF      _cI2CCurrentMsgCount+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CData18
;PIC16F_I2C_SlaveFunctions.c,179 :: 		ucI2CCurrentStatus = _I2C_STATUS_INPROGRESS;
	MOVLW      __I2C_STATUS_INPROGRESS
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,180 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_INPROGRESS;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_INPROGRESS
	MOVWF      INDF+0
;PIC16F_I2C_SlaveFunctions.c,181 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CData_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,182 :: 		}
	GOTO       L_ParseI2CData19
L_ParseI2CData18:
;PIC16F_I2C_SlaveFunctions.c,183 :: 		else if (cI2CCurrentMsgCount == cI2CTotalMsgCount)
	MOVF       _cI2CCurrentMsgCount+0, 0
	XORWF      _cI2CTotalMsgCount+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_ParseI2CData20
;PIC16F_I2C_SlaveFunctions.c,185 :: 		ucI2CCurrentStatus = _I2C_STATUS_END;
	MOVLW      __I2C_STATUS_END
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,186 :: 		ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_END;
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVLW      __I2C_STATUS_END
	MOVWF      INDF+0
;PIC16F_I2C_SlaveFunctions.c,187 :: 		cI2CCurrentRegisterNumber = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F_I2C_SlaveFunctions.c,188 :: 		cI2CTotalMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CTotalMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,189 :: 		cI2CCurrentMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,190 :: 		result = 1;
	MOVLW      1
	MOVWF      ParseI2CData_result_L0+0
;PIC16F_I2C_SlaveFunctions.c,191 :: 		}
L_ParseI2CData20:
L_ParseI2CData19:
;PIC16F_I2C_SlaveFunctions.c,192 :: 		}
L_ParseI2CData17:
;PIC16F_I2C_SlaveFunctions.c,193 :: 		}
L_ParseI2CData13:
;PIC16F_I2C_SlaveFunctions.c,194 :: 		}
L_ParseI2CData10:
;PIC16F_I2C_SlaveFunctions.c,195 :: 		return result;
	MOVF       ParseI2CData_result_L0+0, 0
	MOVWF      R0+0
;PIC16F_I2C_SlaveFunctions.c,196 :: 		}
L_end_ParseI2CData:
	RETURN
; end of _ParseI2CData

_ParseI2CInput:

;PIC16F_I2C_SlaveFunctions.c,210 :: 		void ParseI2CInput(unsigned char input)
;PIC16F_I2C_SlaveFunctions.c,212 :: 		if (ucI2CCurrentStatus == _I2C_STATUS_IDLE || ucI2CCurrentStatus == _I2C_STATUS_ERROR || ucI2CCurrentStatus == _I2C_STATUS_END)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_IDLE
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput54
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_ERROR
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput54
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_END
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput54
	GOTO       L_ParseI2CInput23
L__ParseI2CInput54:
;PIC16F_I2C_SlaveFunctions.c,214 :: 		ParseI2CHeader(input);
	MOVF       FARG_ParseI2CInput_input+0, 0
	MOVWF      FARG_ParseI2CHeader_input+0
	CALL       _ParseI2CHeader+0
;PIC16F_I2C_SlaveFunctions.c,215 :: 		}
	GOTO       L_ParseI2CInput24
L_ParseI2CInput23:
;PIC16F_I2C_SlaveFunctions.c,216 :: 		else if (ucI2CCurrentStatus == _I2C_STATUS_STARTED || ucI2CCurrentStatus == _I2C_STATUS_INPROGRESS)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_STARTED
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput53
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_INPROGRESS
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput53
	GOTO       L_ParseI2CInput27
L__ParseI2CInput53:
;PIC16F_I2C_SlaveFunctions.c,218 :: 		if ((cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber<_I2C_MAX_REGISTERS_COUNT)
	MOVLW      0
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_ParseI2CInput34
	MOVLW      32
	SUBWF      _cI2CCurrentRegisterNumber+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ParseI2CInput34
;PIC16F_I2C_SlaveFunctions.c,219 :: 		&&(ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_STARTED || ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_INPROGRESS))
L__ParseI2CInput52:
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      __I2C_STATUS_STARTED
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput51
	MOVF       _cI2CCurrentRegisterNumber+0, 0
	ADDLW      _ucI2CRegistersStatus+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      __I2C_STATUS_INPROGRESS
	BTFSC      STATUS+0, 2
	GOTO       L__ParseI2CInput51
	GOTO       L_ParseI2CInput34
L__ParseI2CInput51:
L__ParseI2CInput50:
;PIC16F_I2C_SlaveFunctions.c,221 :: 		ParseI2CData(input);
	MOVF       FARG_ParseI2CInput_input+0, 0
	MOVWF      FARG_ParseI2CData_input+0
	CALL       _ParseI2CData+0
;PIC16F_I2C_SlaveFunctions.c,222 :: 		}
	GOTO       L_ParseI2CInput35
L_ParseI2CInput34:
;PIC16F_I2C_SlaveFunctions.c,225 :: 		ucI2CCurrentStatus = _I2C_STATUS_ERROR;
	MOVLW      __I2C_STATUS_ERROR
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,226 :: 		}
L_ParseI2CInput35:
;PIC16F_I2C_SlaveFunctions.c,227 :: 		}
L_ParseI2CInput27:
L_ParseI2CInput24:
;PIC16F_I2C_SlaveFunctions.c,228 :: 		if (ucI2CCurrentStatus == _I2C_STATUS_END)
	MOVF       _ucI2CCurrentStatus+0, 0
	XORLW      __I2C_STATUS_END
	BTFSS      STATUS+0, 2
	GOTO       L_ParseI2CInput36
;PIC16F_I2C_SlaveFunctions.c,230 :: 		ucI2CCurrentStatus = _I2C_STATUS_IDLE;
	MOVLW      __I2C_STATUS_IDLE
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,231 :: 		}
L_ParseI2CInput36:
;PIC16F_I2C_SlaveFunctions.c,232 :: 		}
L_end_ParseI2CInput:
	RETURN
; end of _ParseI2CInput

_ManageI2CBus:

;PIC16F_I2C_SlaveFunctions.c,245 :: 		void ManageI2CBus()
;PIC16F_I2C_SlaveFunctions.c,247 :: 		if (SSPSTAT.R_W == _I2C_WRITE) //The W/R bit (0) indicate a write
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 2
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_WRITE
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus37
;PIC16F_I2C_SlaveFunctions.c,251 :: 		if (SSPSTAT.D_A == _I2C_ADDRESS) //The last received byte was an address
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_ADDRESS
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus38
;PIC16F_I2C_SlaveFunctions.c,255 :: 		cI2CAddress = SSPBUF;
	MOVF       SSPBUF+0, 0
	MOVWF      _cI2CAddress+0
;PIC16F_I2C_SlaveFunctions.c,256 :: 		SSPSTAT.BF = 0;                    // Reset flag Buffer-Full
	BCF        SSPSTAT+0, 0
;PIC16F_I2C_SlaveFunctions.c,257 :: 		}
	GOTO       L_ManageI2CBus39
L_ManageI2CBus38:
;PIC16F_I2C_SlaveFunctions.c,262 :: 		cI2CData = SSPBUF;                    // Read data from SSPBUF
	MOVF       SSPBUF+0, 0
	MOVWF      _cI2CData+0
;PIC16F_I2C_SlaveFunctions.c,264 :: 		ParseI2CInput(cI2CData);
	MOVF       _cI2CData+0, 0
	MOVWF      FARG_ParseI2CInput_input+0
	CALL       _ParseI2CInput+0
;PIC16F_I2C_SlaveFunctions.c,265 :: 		}
L_ManageI2CBus39:
;PIC16F_I2C_SlaveFunctions.c,266 :: 		}
	GOTO       L_ManageI2CBus40
L_ManageI2CBus37:
;PIC16F_I2C_SlaveFunctions.c,270 :: 		if (SSPSTAT.D_A == _I2C_ADDRESS) //The last received byte was an address
	CLRF       R1+0
	BTFSC      SSPSTAT+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      __I2C_ADDRESS
	BTFSS      STATUS+0, 2
	GOTO       L_ManageI2CBus41
;PIC16F_I2C_SlaveFunctions.c,274 :: 		SSPBUF = cI2CData;                    // Write data from cI2CData to SSPBUF
	MOVF       _cI2CData+0, 0
	MOVWF      SSPBUF+0
;PIC16F_I2C_SlaveFunctions.c,275 :: 		}
	GOTO       L_ManageI2CBus42
L_ManageI2CBus41:
;PIC16F_I2C_SlaveFunctions.c,280 :: 		SSPBUF = cI2CAddress;              // Respond with this chip address
	MOVF       _cI2CAddress+0, 0
	MOVWF      SSPBUF+0
;PIC16F_I2C_SlaveFunctions.c,281 :: 		}
L_ManageI2CBus42:
;PIC16F_I2C_SlaveFunctions.c,282 :: 		}
L_ManageI2CBus40:
;PIC16F_I2C_SlaveFunctions.c,283 :: 		SSPCON.CKP = 1;                       // Allow clock stretching
	BSF        SSPCON+0, 4
;PIC16F_I2C_SlaveFunctions.c,284 :: 		PIR1.SSPIF = 0;                       // Reset SSP-Interrupt-Flag
	BCF        PIR1+0, 3
;PIC16F_I2C_SlaveFunctions.c,285 :: 		}
L_end_ManageI2CBus:
	RETURN
; end of _ManageI2CBus

_InitI2CSlave:

;PIC16F_I2C_SlaveFunctions.c,301 :: 		void InitI2CSlave(void)
;PIC16F_I2C_SlaveFunctions.c,304 :: 		for (counter = 0; counter<_I2C_MAX_REGISTERS_COUNT; counter++)
	CLRF       R1+0
L_InitI2CSlave43:
	MOVLW      32
	SUBWF      R1+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_InitI2CSlave44
;PIC16F_I2C_SlaveFunctions.c,306 :: 		ucI2CRegisters[counter] = 0;
	MOVF       R1+0, 0
	ADDLW      _ucI2CRegisters+0
	MOVWF      FSR
	CLRF       INDF+0
;PIC16F_I2C_SlaveFunctions.c,304 :: 		for (counter = 0; counter<_I2C_MAX_REGISTERS_COUNT; counter++)
	INCF       R1+0, 1
;PIC16F_I2C_SlaveFunctions.c,307 :: 		}
	GOTO       L_InitI2CSlave43
L_InitI2CSlave44:
;PIC16F_I2C_SlaveFunctions.c,308 :: 		cI2CCurrentRegisterNumber = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentRegisterNumber+0
;PIC16F_I2C_SlaveFunctions.c,309 :: 		cI2CTotalMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CTotalMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,310 :: 		cI2CCurrentMsgCount = -1;
	MOVLW      255
	MOVWF      _cI2CCurrentMsgCount+0
;PIC16F_I2C_SlaveFunctions.c,311 :: 		ucI2CCurrentStatus = _I2C_STATUS_IDLE;
	MOVLW      __I2C_STATUS_IDLE
	MOVWF      _ucI2CCurrentStatus+0
;PIC16F_I2C_SlaveFunctions.c,314 :: 		OSCCON = 0b01110001;             // Sync Oscillator Control Register
	MOVLW      113
	MOVWF      OSCCON+0
;PIC16F_I2C_SlaveFunctions.c,349 :: 		TRISC = TRISC | 0b00011000;              // Register Port C (0: Output, 1: Input)
	MOVLW      24
	IORWF      TRISC+0, 1
;PIC16F_I2C_SlaveFunctions.c,362 :: 		SSPCON = 0b00100110;             // Sync Serial Port Control Register 1
	MOVLW      38
	MOVWF      SSPCON+0
;PIC16F_I2C_SlaveFunctions.c,420 :: 		SSPCON2 = 0b00110110;            // Sync Serial Port Control Register 2
	MOVLW      54
	MOVWF      SSPCON2+0
;PIC16F_I2C_SlaveFunctions.c,465 :: 		SSPSTAT = 0b10000000;
	MOVLW      128
	MOVWF      SSPSTAT+0
;PIC16F_I2C_SlaveFunctions.c,467 :: 		cI2CAddress = _I2C_CHIP_ADDRESS;
	MOVLW      63
	MOVWF      _cI2CAddress+0
;PIC16F_I2C_SlaveFunctions.c,468 :: 		cI2CAddress = cI2CAddress << 1;       //Move address to left one bit
	RLF        _cI2CAddress+0, 1
	BCF        _cI2CAddress+0, 0
;PIC16F_I2C_SlaveFunctions.c,469 :: 		cI2CAddress.F0 = 0;                   // This is a write from the master perspective
	BCF        _cI2CAddress+0, 0
;PIC16F_I2C_SlaveFunctions.c,470 :: 		SSPADD = cI2CAddress;
	MOVF       _cI2CAddress+0, 0
	MOVWF      SSPADD+0
;PIC16F_I2C_SlaveFunctions.c,474 :: 		PIE1 = PIE1 | 0b00001000;               // Peripheral Interrupt Enable Register 1 (Bank 1)
	BSF        PIE1+0, 3
;PIC16F_I2C_SlaveFunctions.c,500 :: 		INTCON = INTCON | 0b11000000;        // Interrupt-Control-Register (Bank 1)
	MOVLW      192
	IORWF      INTCON+0, 1
;PIC16F_I2C_SlaveFunctions.c,526 :: 		}
L_end_InitI2CSlave:
	RETURN
; end of _InitI2CSlave
